#include "stdafx.h"
#include "NPResourceFile.h"

CNPResourceFile::CNPResourceFile( void )
{
	m_hModule = NULL;
	m_hMem = NULL;
	m_hGlobal = NULL;
	m_szFileName.Empty();
	m_szResourceName.Empty();
	m_szType.Empty();
	m_hRSrc = NULL;
	m_dwLen = 0;
}
CNPResourceFile::~CNPResourceFile( void )
{
	Close();
}
BOOL CNPResourceFile::Open( LPCTSTR lpszURL, DWORD dwFlags /*= 0 */ )
{
	(dwFlags);
	BOOL bSuccess = TRUE;

	CString szURL = lpszURL;
	szURL.MakeLower();
	if ( szURL.Find( _T("res://") ) == -1 )
	{
		return FALSE;
	}
	int nPos1 = szURL.Find( _T('/'), 6 );
	if ( nPos1 == -1 )
	{
		return FALSE;
	}
	m_szFileName = szURL.Mid( 6, nPos1 - 6 );

	int nPos2 = szURL.Find( _T('/'), nPos1 + 1 );
	if ( nPos2 == -1 )
	{
		return FALSE;
	}
	m_szType = szURL.Mid( nPos1 + 1, nPos2 - nPos1 - 1 );
	m_szResourceName = szURL.Right( szURL.GetLength() - nPos2 - 1 );

	m_hModule = LoadLibrary( m_szFileName );

	m_hRSrc = FindResource( m_hModule, MAKEINTRESOURCE( _ttoi( m_szResourceName ) ), m_szType );
	DWORD dwError = GetLastError();
	(dwError);
	m_dwLen = SizeofResource( m_hModule, m_hRSrc );
	return bSuccess;
}
void CNPResourceFile::Close()
{
	if ( m_hGlobal )
	{
		GlobalUnlock( m_hGlobal );
		GlobalFree( m_hGlobal );
		m_hGlobal = NULL;
	}
	if ( m_hMem )
	{
		FreeResource( m_hMem );
		m_hMem = NULL;
	}
	if ( m_hModule )
	{
		FreeLibrary( m_hModule );
		m_hModule = NULL;
	}
}
DWORD CNPResourceFile::Read( void* lpBuf, DWORD dwCount /*= 0 */ )
{
	(dwCount);
	m_hMem = LoadResource( m_hModule, m_hRSrc );

	LPVOID ptr = ( LPVOID )LockResource( m_hMem );

	m_hGlobal = GlobalAlloc( GMEM_MOVEABLE, m_dwLen );
	void* pData = GlobalLock( m_hGlobal );
	CopyMemory( pData, ptr, m_dwLen );
	
	//lpBuf = pData;
	CopyMemory( lpBuf, pData, m_dwLen );

	//GlobalUnlock( m_hGlobal );
	return m_dwLen;
}
ULONGLONG CNPResourceFile::GetSize()
{
	return ( ULONGLONG )m_dwLen;
}